---
title: What's New in Deer Park Alpha
slug: Mozilla/Firefox/Releases/1.5/What_s_new_in_1.5_alpha
tags:
  - API
  - CSS
  - DOM
  - Extensions
  - Graphics
  - HTML
  - JavaScript
  - SVG
---
<div>{{FirefoxSidebar}}</div>

<p>This page is based largely on <a class="external" href="http://www.squarefree.com/burningedge/releases/1.1.html" rel="freelink">http://www.squarefree.com/burningedg...eases/1.1.html</a> (thanks Jesse).</p>

<h3 id="New_Web_Developer_Features">New Web Developer Features</h3>

<h4 id="HTML">HTML</h4>

<dl>
 <dt>Elements with <code>tabindex="-1"</code> should be focusable</dt>
 <dd>Elements with a negative tabIndex attribute can now have focus, even though they are not in the tab order.</dd>
</dl>

<dl>
 <dt>Object should submit</dt>
 <dd>In accordance with the HTML4 specification, <code>&lt;object&gt;</code> elements can now be submitted as part of a form.</dd>
</dl>

<h4 id="CSS">CSS</h4>

<dl>
 <dt>CSS2 quotes nesting</dt>
 <dd>Starting with this release, the <a class="external" href="http://www.w3.org/TR/CSS21/generate.html#quotes-specify"><code>quotes</code> CSS2 property</a> is fully supported, with the correct quote (depending on the nesting level) used for open-quote and close-quote.</dd>
</dl>

<dl>
 <dt>CSS3 <code><span class="nowiki">:only-child</span></code></dt>
 <dd>This CSS3 selector allows <a class="external" href="http://www.w3.org/TR/2001/CR-css3-selectors-20011113/#only-child-pseudo">selecting an element</a> that has no other elements as siblings in the DOM.</dd>
</dl>

<dl>
 <dt>CSS3 columns</dt>
 <dd>An experimental implementation of the proposed <a class="external" href="http://www.w3.org/TR/2001/WD-css3-multicol-20010118/">CSS3 multicolumn layout</a> draft. This allows easily doing newspaper-like multicolumn presentation.</dd>
</dl>

<dl>
 <dt>CSS3 <code>overflow-x</code> and <code>overflow-y</code> properties</dt>
 <dd>These properties can be used to control the overflow behavior in the horizontal and vertical directions somewhat independently. For example, overflow in the horizontal direction could be hidden while overflow in the vertical direction can be scrolled to.</dd>
</dl>

<dl>
 <dt>CSS3 cursors</dt>
 <dd>More <a class="external" href="http://www.w3.org/TR/css3-ui/#cursor">mouse cursor names</a> are now supported.</dd>
</dl>

<dl>
 <dt>URI values on CSS <code>cursor</code> properties</dt>
 <dd>On Windows, OS/2 and Linux (Gtk+ 2.x) one can now use an arbitrary image as the mouse cursor while a given DOM node is being hovered. Any image format supported by Gecko can be used for the image. (SVG, animated GIF, and ANI cursors are not supported.) See <a href="en/Using_URL_values_for_the_cursor_property">Using URL values for the cursor property</a> for a description of the feature.</dd>
</dl>

<dl>
 <dt><code>-moz-outline-radius</code></dt>
 <dd>CSS outlines can now have rounded corners.</dd>
</dl>

<dl>
 <dt>CSS <code>outline</code> property</dt>
 <dd><a class="external" href="http://www.w3.org/TR/css3-ui/#outline1">CSS outlines</a> can now be used. These differ from borders in that they don't affect the page layout.</dd>
</dl>

<dl>
 <dt>Counters in CSS-generated content</dt>
 <dd><a class="external" href="http://www.w3.org/TR/CSS21/generate.html#counters">CSS2 counters</a> are now completely supported (the implementation doesn't match the current CSS2.1 draft, but matches the upcoming one). This allows automatic numbering of sections, headings, and so forth via stylesheets.</dd>
</dl>

<h4 id="JavaScript_and_DOM">JavaScript and DOM</h4>

<dl>
 <dt>Array extras</dt>
 <dd>New methods have been added to the Array object to facilitate common tasks. See <a href="en/Core_JavaScript_1.5_Reference/Objects/Array">JavaScript 1.5 Array Object</a>.</dd>
</dl>

<dl>
 <dt><code>document.open("text/plain")</code></dt>
 <dd>Text written in new documents created with document.open("text/plain") is now treated as text rather than HTML, so line breaks will remain intact and tags will not be parsed.</dd>
</dl>

<dl>
 <dt>XML Events</dt>
 <dd>"XML Events" is a W3C specification to provide XML languages with the ability to integrate declarative event listeners and event handlers.</dd>
</dl>

<dl>
 <dt>Cancelling keydown</dt>
 <dd>Cancelling the keydown event now properly cancels any corresponding keyup/keypress events, per the DOM specification.</dd>
</dl>

<dl>
 <dt>Accessibility APIs for DHTML</dt>
 <dd>Mozilla now allows DHTML authors to add role and state semantics to custom elements, and exposes that information via MSAA and ATK.</dd>
</dl>

<dl>
 <dt>DHTML Performance Fixes</dt>
 <dd>A number of changes were made to significantly improve DHTML speed and smoothness.</dd>
</dl>

<h4 id="Graphics">Graphics</h4>

<dl>
 <dt>SVG Support</dt>
 <dd>SVG is W3C specification providing resolution-independent scalable vector graphics, along with a DOM. A technology preview of native SVG support is included in this release. Currently a subset of SVG 1.1 Full, missing functionality includes filters, declarative animation, and SVG defined fonts.</dd>
</dl>

<dl>
 <dt><code>&lt;canvas&gt;</code> Support</dt>
 <dd><code>&lt;canvas&gt;</code> is a scriptable drawing surface for dynamically creating bitmap graphics. For a further introduction, see <a href="en/Drawing_Graphics_with_Canvas">Drawing Graphics with Canvas</a>.</dd>
</dl>

<h4 id="Miscellaneous">Miscellaneous</h4>

<dl>
 <dt>Support HTTP/1.1 408 response code</dt>
 <dd>A persistent connection is now correctly closed when a 408 response code (Request timeout) is received. The request is retried in a new connection.</dd>
</dl>

<dl>
 <dt>URIs always sent as UTF8</dt>
 <dd>URIs are now always sent to the server as UTF8, regardless of the linking page's encoding. This fixes images and links on sites with non-ASCII filenames.</dd>
</dl>

<dl>
 <dt>XForms support</dt>
 <dd>The <a class="external" href="http://www.w3.org/MarkUp/Forms/">W3C's XML Forms</a> language allows writing complex forms in XML, and includes features that regular HTML forms do not have, such as client side validation against <a class="external" href="http://www.w3.org/XML/Schema">XML Schema</a> and XML submission/retrieval. Support for XForms comes as an extension, see <a class="external" href="http://www.mozilla.org/projects/xforms/">Mozilla XForms Project Page</a>.</dd>
</dl>

<h3 id="New_Extension_Developer_Features">New Extension Developer Features</h3>

<dl>
 <dt>Hidden referrer column for history</dt>
 <dd>Extensions can now access the referer information for pages stored in the browser history. This feature can be used to provide alternate history views and other useful functionality. {{bug(128398) }}</dd>
</dl>

<dl>
 <dt>API for prioritizing HTTP connections</dt>
 <dd>The Mozilla networking library now supports the prioritization of connections to a specific server. See {{ Interface("nsISupportsPriority") }}. {{bug(278531) }}</dd>
</dl>

<dl>
 <dt>API for managing user and UA stylesheets</dt>
 <dd>Extensions can now register stylesheet URIs as additional user and UA stylesheets. This means extensions no longer have to try to edit <code>userContent.css</code> to add styling (say for XBL binding attachment) to web pages. See <a href="en/Using_the_Stylesheet_Service">Using the Stylesheet Service</a>.</dd>
</dl>

<dl>
 <dt>API for configuring proxies</dt>
 <dd>It is now possible for extensions to easily override the proxy configuration without affecting user-visible preferences. See {{ Interface("nsIProtocolProxyService") }}, {{ Interface("nsIProtocolProxyFilter") }}, and {{ Interface("nsIProtocolProxyCallback") }}. {{bug(282442) }}</dd>
</dl>

<dl>
 <dt>Dynamic Overlays</dt>
 <dd>Loading of XUL overlays after the document has been displayed is now supported. See {{ Interface("nsIDOMXULDocument") }}. {{bug(282103) }}</dd>
</dl>

<dl>
 <dt>E4X</dt>
 <dd>The Mozilla JavaScript engine now supports ECMAScript for XML (E4X), a draft ECMA standard that adds native XML datatypes to the language and provides operators for common XML operations. See <a class="external" href="http://www.ecma-international.org/publications/standards/Ecma-357.htm">the ECMA specification</a>. {{bug(246441)}}</dd>
</dl>

<dl>
 <dt>Translucent Windows (Windows/Linux)</dt>
 <dd>On Windows and Linux, XUL windows with a transparent background are now supported. This allows whatever is below the window to shine through the window background.</dd>
</dl>

<dl>
 <dt>Adding tokens to the User-Agent string</dt>
 <dd>It is now possible for applications, extensions, and vendors to all add tokens to the User-Agent string (using default preferences) without overwriting each other. See <a class="external" href="http://www.mozilla.org/build/revised-user-agent-strings.html">documentation</a>. {{bug(274928) }}</dd>
</dl>

<dl>
 <dt>Toolkit chrome registry</dt>
 <dd>Chrome registration has been significantly improved to use simple plaintext chrome registration manifests, and no longer keeps the chrome.rdf/overlayinfo cache. See <a href="en/Chrome_Registration">Chrome Registration</a>.</dd>
</dl>

<dl>
 <dt>Extension Manager</dt>
</dl>

<ul>
 <li>It is now possible to have Extensions outside the profile and application Extensions directories.</li>
 <li>Installing extensions can now be done by dropping an XPI into the profile or application Extensions directory.</li>
 <li>Uninstalling an Extension now involves deleting its folder from the profile or application Extensions directory.</li>
</ul>

<dl>
 <dt>New Preferences bindings</dt>
 <dd>These <a class="external" href="http://forums.mozillazine.org/viewtopic.php?t=263028">new bindings</a> make it easier to create preferences windows for extensions. The new preferences windows support instant-apply behavior, which is enabled by default on Mac and Linux.</dd>
</dl>

<dl>
 <dt>API for implementing new command-line switches</dt>
 <dd>An API has been introduced so that extensions can easily handle complex command-line flags. This API will be stable and frozen for 1.1. See the interfaces {{ Interface("nsICommandLine") }} and {{ Interface("nsICommandLineHandler") }}.</dd>
</dl>

<dl>
 <dt>XTF Support</dt>
 <dd>The eXtensible Tag Framework allows adding support for new namespaces using XPCOM components to Mozilla (written in JavaScript or C++). For example, the <a class="external" href="http://www.mozilla.org/projects/xforms">Mozilla XForms Project</a> uses XTF to add support for the XForms namespace. See <a class="external" href="http://www.croczilla.com/xtf">XTF Home Page</a></dd>
</dl>

<h3 id="New_Browser_Features">New Browser Features</h3>

<h4 id="Improved_Preferences">Improved Preferences</h4>

<dl>
 <dt>Instant Apply behaviour on Linux and Mac</dt>
 <dd>Changes made in the Preferences window now apply immediately, in line with typical behaviour in other Mac OS X and GNOME applications. This changes conforms with the Apple and GNOME Human Interface Guidelines.</dd>
</dl>

<dl>
 <dt>Searchable download actions manager</dt>
 <dd>It is possible to search the Download Actions manager by file extension or description.</dd>
</dl>

<dl>
 <dt>Searchable cookie manager</dt>
 <dd>Cookies can be searched by hostname/domain and cookie name, and are organized by hostname in a tree format instead of a flat list.</dd>
</dl>

<h4 id="Deployment">Deployment</h4>

<dl>
 <dt>Firefox MSI package</dt>
 <dd>The new MSI installation package facilitates distibuted installation and provides greater flexibility to network administrators wanting to deploy Firefox in a corporate environment.</dd>
</dl>

<dl>
 <dt>Support for profile "temp" directory on local filesystem</dt>
 <dd>It is now possible to store the network cache (copies of visited webpages) and the XUL fastload cache (precompiled user interface code) on a local disk, while keeping the rest of the profile data on a network drive. This will increase performance and reduce network traffic for users in a network environment.</dd>
</dl>

<h4 id="Other">Other</h4>

<dl>
 <dt>"Sanitize" privacy feature</dt>
 <dd>The "Sanitize" feature provides an easy way to quickly remove browsing history, cookies, cache, saved form information, and other personal data. The items to be removed can be customized, and the feature can be activated using either a keyboard shortcut or through a menu item.</dd>
</dl>

<dl>
 <dt>Image thumbnails as tab icons</dt>
 <dd>When viewing images, tab icons now display thumbnails of the displayed image.</dd>
</dl>

<dl>
 <dt>Fast back (and forward)</dt>
 <dd>This very experimental feature allows much faster session history navigation. The feature is off by default but can be enabled for testing purposes by setting the <code>browser.sessionhistory.max_viewers</code> preference to a nonzero number.</dd>
</dl>

<dl>
 <dt>Anonymous FTP login failure behaviour</dt>
 <dd>FTP users are now prompted to input a name and password if anonymous access fails.</dd>
</dl>

<dl>
 <dt>CSS at-rule for matching on site/document URL</dt>
 <dd>The new <code>@-moz-document</code> rule gives users the ability to match page objects per-site, using CSS. This makes it possible to include site-specific rules in user style sheets (userContent.css). <a class="external" href="http://lists.w3.org/Archives/Public/www-style/2004Aug/0135.html">David Baron's post to <code>www-style</code></a> explains how the rule can be used.</dd>
</dl>

<h3 id="Notable_Bug_Fixes">Notable Bug Fixes</h3>

<p>Not sure we need/want this.</p>

<h3 id="More_Information">More Information</h3>

<p>Not sure we need/want this</p>
